{***(V.K.)**********************************************************************
	IEHelper - sceleton BHO (IE's event sinking and manipulation)
  implementation in OP.

  Developed by Vadim Krochak (based on IEHelper VC++ MSDN sample).
*******************************************************************************}

unit DOMAccess;

interface

uses SHDocVw_TLB;

function HistoryCount(AWebBrowser: IWebBrowser2): SmallInt;

//******************************************************************************
//******************************************************************************

implementation

uses Windows, SysUtils, MSHTML_TLB;

{***(V.K.)**********************************************************************
  Function   :HistoryCount
  Purpose    :get history count for client, nice sample for DOM.
  Parameters :AWebBrowser - IWebBrowser2
  Returns    :history count for current client
*******************************************************************************}
function HistoryCount(AWebBrowser: IWebBrowser2): SmallInt;
var
	app: IWebBrowserAppDisp;
  doc: IHTMLDocument2;
  wnd: IHTMLWindow2;
  hist: IOmHistory;
begin
  Result := 0;

	if not Assigned(AWebBrowser) then	Exit;

  //(VK): for safety:
	app 	:= nil;
  doc 	:= nil;
  wnd 	:= nil;
  hist 	:= nil;

	try
    app := AWebBrowser.Get_Application_ as IWebBrowserAppDisp;
		if not Assigned(app) then	Exit;

    doc := app.Document as IHTMLDocument2;

    //(VK): document loaded:
    if Assigned(doc) then
    begin
      wnd := doc.Get_parentWindow;
			if not Assigned(wnd) then	Exit;
      hist := wnd.history;
      if not Assigned(hist) then	Exit;
      Result := hist.length;
    end;// If
  except
    on E: Exception do
    begin
      Windows.MessageBox(0, PChar('HistoryCount - exception raised: ' + E.Message), 'IEHelperOP', MB_OK);
    end;
  end;// Try-Except

end;

end.////////////////////////////////////////////////////////////////////////////
